using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Drawing;
using PlexityHide.GTP;
using PlexityHide.GTP.WEB;

public partial class _Default : System.Web.UI.Page, IPostBackEventHandler
{

    private DataSet dataSet1 = new DataSet();

    protected void Page_Load(object sender, EventArgs e)
    {

        Gantt_ASP1.OnGanttRow_ClientClick += new GanttRowClickEvent(Gantt_ASP1_OnGanttRow_ClientClick);
        Gantt_ASP1.Gantt.Grid.GridStructure.RootNodes.Clear();
        TimeItemLayout til = new TimeItemLayout();
        Gantt_ASP1.Gantt.TimeItemLayouts.Add(til);
        til.TimeItemStyle = TimeItemStyle.Glossy;
        til.Color = Color.Honeydew;
        til.GradientColor = Color.GreenYellow;
        til.BrushKind = BrushKind.GradientDiagonal;
        til.SelectHandles = Color.Black;
        til.Name = "spacy";




        if (Page.Session["loaded"] == null || (bool)(Page.Session["loaded"]) == false)
        {

            dataSet1.ReadXml(Page.MapPath(".\\App_Data\\DemoData.xml"));
            dataSet1.Relations.Add(new DataRelation("timeitems", dataSet1.Tables["gridnode"].Columns["id"], dataSet1.Tables["timeitem"].Columns["owner"]));
            dataSet1.Relations.Add(new DataRelation("subnodes", dataSet1.Tables["gridnode"].Columns["id"], dataSet1.Tables["gridnode"].Columns["owner"]));

            Page.Session.Add("thedata", dataSet1);
            Page.Session.Add("loaded", true);
            //Page.Cache.Add("TheData_" + Page.Session.SessionID, dataSet1, null, DateTime.MaxValue, new TimeSpan(1, 1, 0), System.Web.Caching.CacheItemPriority.Default, null);
        }
        else
            dataSet1 = Page.Session["thedata"] as DataSet;

        Gantt_ASP1.Gantt.PyjamasColor = Color.WhiteSmoke;
        Gantt_ASP1.Gantt.PyjamasGradientColor = Color.White;
        Gantt_ASP1.Gantt.BackColor = Color.White;
        Gantt_ASP1.Gantt.Grid.Columns.Clear();
        Gantt_ASP1.Gantt.Grid.Columns.AddNew(PlexityHide.GTP.CellType.SingleText);
        Gantt_ASP1.Gantt.Grid.Columns[0].DataSourceColumn = "text";
        Gantt_ASP1.Gantt.Grid.Columns[0].Tree = true;
        Gantt_ASP1.Gantt.Grid.Columns.AddNew(PlexityHide.GTP.CellType.SingleText);
        Gantt_ASP1.Gantt.Grid.Columns[1].DataSourceColumn = "";


        /// Add a Select button in the grid
        Gantt_ASP1.Gantt.Grid.Columns.AddNew(PlexityHide.GTP.CellType.SingleText);
        Gantt_ASP1.Gantt.Grid.Columns[2].DataSourceColumn = "";
        Gantt_ASP1.OnPostBackEvent += new EventHandler(Gantt_ASP1_OnPostBackEvent);
        CellLayout cl = new CellLayout();
        cl.BackgroundColor = Color.Yellow;
        cl.BackgroundUse = true;
        cl.Name = "SelectedRow";
        Gantt_ASP1.Gantt.Grid.CellLayouts.Add(cl);

        /// done


        Gantt_ASP1.Gantt.Grid.OnNodeInserted += new NodeEventHandler(Grid_OnNodeInserted);
        Gantt_ASP1.Gantt.OnTimeItem_ChangeRow += new TimeItemEvent(Gantt_OnTimeItem_ChangeRow);
        Gantt_ASP1.Gantt.OnTimeItem_Move += new TimeItemEvent(Gantt_OnTimeItem_Move);

        Gantt_ASP1.Gantt.GridWidth = 350;

        // root nodes data bind
        DataView dv = new DataView(dataSet1.Tables["gridnode"]);
        dv.RowFilter = "owner is null";
        Gantt_ASP1.Gantt.GridProperties.RootNodes_DataSource = dv;

        // links databind
        Gantt_ASP1.Gantt.TimeItemLinks.CreationTimeItemLinkDrawStyle = TimeItemLinkDrawStyle.ZStyle;
        Gantt_ASP1.Gantt.TimeItemLinks.NameInDS_StartKey = "owner";
        Gantt_ASP1.Gantt.TimeItemLinks.NameInDS_TargetKey = "target";
        Gantt_ASP1.Gantt.TimeItemLinks.DataSource = new DataView(dataSet1.Tables["link"]);

        Gantt_ASP1.Gantt.ScheduleMode = CheckBox1.Checked;

        // Demo of new event to tune the cell content
        Gantt_ASP1.OnCellContentTuning += new CellContentTuningEvent(Gantt_ASP1_OnCellContentTuning);

        if (!Page.IsPostBack)
        {
            Gantt_ASP1.StartTime = new DateTime(2007, 1, 1);
            Gantt_ASP1.StopTime = Gantt_ASP1.StartTime.AddDays(25);
        }

        //Gantt_ASP1.HideGrid = true;

        Gantt_ASP.ClientSideJavaScript_TimeItemInit = "aImgElement.title=aClientTimeItem.UserString;\r\n";

    }


    void Gantt_ASP1_OnCellContentTuning(Gantt_ASP aGantt, CellContentTuningArgs e)
    {
        if (e.Cell.Column.Index == 0)
        {
            string orgcontent = e.Content;
            if (!orgcontent.Contains("<") && e.Cell.GridNode != null) // avoid to paste an image into other html content already inplace, and avoid header
                e.Content = string.Format("<img src=\"happy.jpg\" alt=\"{0}\" height=\"10px\" width=\"10px\"/>{0}", orgcontent);
        }
        else if (e.Cell.Column.Index == 2)
        {
            if (!e.Content.Contains("<") && e.Cell.GridNode != null)
            {
                string postbackref = "Select:" + Gantt_ASP1.GridNodeKey(e.Cell.GridNode);
                e.Content = "<a href=\"javascript:" + Page.ClientScript.GetPostBackEventReference(aGantt, postbackref) + "\">Select</a>";
            }

        }

    }

    void Gantt_ASP1_OnPostBackEvent(object sender, EventArgs e)
    {
        string[] parts = Page.Request.Params[2].Split(':');
        if (parts.Length > 1)
        {
            if (parts[0] == "Select")
            {
                GridNode gn = Gantt_ASP1.GridNodeFromKey(parts[1]);
                if (gn != null)
                {
                    Gantt_ASP1.Gantt.Grid.FocusedCell = gn.GetCell(0);
                    this.ViewState["SelectedNode"] = parts[1];
                }
            }
        }
    }




    void Gantt_OnTimeItem_Move(Gantt aGantt, TimeItemEventArgs e)
    {
        if (e.NewGanttRow != null && e.NewGanttRow != e.TimeItem.GanttRow)
        {
            // The user wants to switch rows... 
            //Ok, but lets zero the time move, when switching rows...
            e.Diff = TimeSpan.Zero;
        }
    }

    void Gantt_ASP1_OnGanttRow_ClientClick(Gantt_ASP aGantt, GanttRowClickEventArgs e)
    {
        if (aGantt.MouseButton_ClientSide == 1 && e.ThisClickSelectedLink == null)
        {
            DataRow dr = dataSet1.Tables["timeitem"].NewRow();
            dr["owner"] = (e.Row.GridNode.ListItemWhenDataBound() as DataRowView)["id"];
            dr["start"] = aGantt.Gantt.DateScaler.PixelToTime(e.X);
            dr["stop"] = aGantt.Gantt.DateScaler.PixelToTime(e.X).AddDays(2);
            dataSet1.Tables["timeitem"].Rows.Add(dr);
        }
        LabelClickInfo.Text = "You clicked GanttRow with id " + ((e.Row.GridNode.ListItemWhenDataBound() as DataRowView)["id"]).ToString();
    }

    void Gantt_OnTimeItem_ChangeRow(Gantt aGantt, TimeItemEventArgs e)
    {
        e.Allow = false; // We are databound so we change the data and wait for the GUI update
        if (e.NewGanttRow != null)
        {
            // Change the data so that this time item is owned by the new row...
            (e.TimeItem.ListItemWhenDataBound() as DataRowView).BeginEdit();
            (e.TimeItem.ListItemWhenDataBound() as DataRowView)["owner"] = (e.NewGanttRow.GridNode.ListItemWhenDataBound() as DataRowView)["id"];
            (e.TimeItem.ListItemWhenDataBound() as DataRowView).EndEdit();
        }
    }

    void Grid_OnNodeInserted(Grid aGrid, NodeEventArgs e)
    {
        // For each new node we set up databind for subnodes...
        e.GridNode.SubNodes_DataSource = (e.GridNode.ListItemWhenDataBound() as DataRowView).CreateChildView("subnodes");


        string postbackref = "DELETE:" + Gantt_ASP1.GridNodeKey(e.GridNode);
        string deletecontent = "<a href=\"javascript:" + Page.ClientScript.GetPostBackEventReference(this, postbackref) + "\">Delete</a>";
        e.GridNode.GetCell(1).Content.Value = deletecontent;

        // and for time items
        GanttRow gr = Gantt.GanttRowFromGridNode(e.GridNode);
        gr.IncreaseRowHeightOnCollision = true;
        gr.IncreaseRow_SuggestedHeightPerItem = 20;
        gr.Layers[0].TimeItemLayout = "spacy";
        gr.Layers[0].NameInDS_Identity = "id";
        gr.Layers[0].NameInDS_Start = "start";
        gr.Layers[0].NameInDS_Stop = "stop";
        gr.Layers[0].DataSource = (e.GridNode.ListItemWhenDataBound() as DataRowView).CreateChildView("timeitems");
    }

    private void InitializeComponent()
    {

    }


    protected void CheckBox1_CheckedChanged(object sender, EventArgs e)
    {
        Gantt_ASP1.Gantt.ScheduleMode = CheckBox1.Checked;
    }
    protected void Gantt_ASP1_OnTimeItem_ClientClick(Gantt aGantt, TimeItemEventArgs e)
    {

        LabelClickInfo.Text = e.TimeItem.Start.ToShortDateString();
    }
    protected void Gantt_ASP1_OnNode_ClientClick(Grid aGrid, NodeEventArgs e)
    {
        LabelClickInfo.Text += " ClientClick:" + e.GridNode.CellValueAsString(0);

    }

    protected void ButtonAddMoreRows_Click(object sender, EventArgs e)
    {
        for (int i = 0; i < 20; i++)
        {
            DataRow dr = dataSet1.Tables["GridNode"].NewRow();
            dr["text"] = "Demodata" + dataSet1.Tables["GridNode"].Rows.Count.ToString();
            dr["id"] = dataSet1.Tables["GridNode"].Rows.Count + 10000;
            dataSet1.Tables["GridNode"].Rows.Add(dr);

            DataRow dr2 = dataSet1.Tables["GridNode"].NewRow();
            dr2["text"] = "Demodata SubNode" + dataSet1.Tables["GridNode"].Rows.Count.ToString();
            dr2["id"] = dataSet1.Tables["GridNode"].Rows.Count + 10000;
            dr2["owner"] = dr["id"];
            dataSet1.Tables["GridNode"].Rows.Add(dr2);


        }
    }

    protected void ButtonGotoPage_Click(object sender, EventArgs e)
    {
        Gantt_ASP1.CurrentPage = 3;
    }



    protected void Button1_Click(object sender, EventArgs e)
    {
        Gantt_ASP1.HideGrid = true;
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        Gantt_ASP1.HideGrid = false;
    }

    protected void Gantt_ASP1_OnTimeItemUserStringPrepare(Gantt_ASP aGantt, TimeItemUserStringPrepareArgs e)
    {
        e.result = "This time item starts st " + e.ti.Start.ToLongDateString();
    }

    protected void Gantt_ASP1_OnNode_ClientClick_NodeKey(object sender, ClientClick_NodeKeyArgs e)
    {
        LabelClickInfo.Text += " NodeKey:" + e.NodeKey;
    }



    private bool _deferActualDeleteUntilViewStateIsFullyApplied;
    private string _idToDelete;



    #region IPostBackEventHandler Members

    public void RaisePostBackEvent(string eventArgument)
    {
        string[] parts = eventArgument.Split(':');
        if (parts.Length > 1)
        {
            if (parts[0] == "DELETE")
            {
                _deferActualDeleteUntilViewStateIsFullyApplied = true;
                _idToDelete = parts[1];
            }
        }
    }

    #endregion

    protected void Gantt_ASP1_OnClientSideChangesApplied(object sender, EventArgs e)
    {
        if (_deferActualDeleteUntilViewStateIsFullyApplied)
        {
            GridNode gn_todelete = Gantt_ASP1.GridNodeFromKey(_idToDelete);
            if (gn_todelete != null && gn_todelete.ListItemWhenDataBound() != null)
            {

                (gn_todelete.ListItemWhenDataBound() as DataRowView).Delete();
            }
        }

            string s = this.ViewState["SelectedNode"] as string;
            if (s != null)
            {
                GridNode gn = Gantt_ASP1.GridNodeFromKey(s);
                if (gn != null)
                {
                    gn.SetCellLayoutOnAll(Gantt_ASP1.Gantt.Grid.CellLayouts.GetFromName("SelectedRow"));
                }
            }



        // We are changing the data then it will go back... dataSet1.WriteXml(Page.MapPath(".\\App_Data\\DemoData.xml"));

    }

    protected void ToolkitScriptManager1_ResolveScriptReference(object sender, ScriptReferenceEventArgs e)
    {

    }
}
